
% DLC Algorithm
function [ACC,ARI,NMI] = DLC_Main(X,Modes)
[Pm.Xlth,Pm.Xwd]=size(X); % fetch the statistics of data set
XLable=(X(:,Pm.Xwd));
Pm.Xwd=Pm.Xwd-1;
X=X(:,1:Pm.Xwd);
Pm.k=max(XLable);
NumVal=zeros(1,Pm.Xwd);
for i=1:Pm.Xwd
    NumVal(i)=length(unique(X(:,i)));
end
DistW=cell(1,Pm.Xwd);  % initialize the distance weights 
for i=1:Pm.Xwd
    DistW{i}(1:NumVal(i)-1)=1/(NumVal(i)-1);
end
ModeMtx=cell(Pm.k,Pm.Xwd); % form k cluster descriptors according to the initialized k modes
for i=1:Pm.k
    for j=1:Pm.Xwd
        ModeMtx{i,j}=zeros(1,NumVal(j));
        ModeMtx{i,j}(Modes(i,j))=1;
    end    
end
LctRecFOld=zeros(Pm.Xlth,1); % initialize the 2nd partition Q in Step 2 of the proposed DLC Algorithm
LctRecC=zeros(Pm.Xlth,1); % initialize the 1st partition Q ... ...
FChange=1; % set convergence judger for launching the algorithm loop (Step 2 - 3 of DLC Algorithm)
LoopD=0; % set loop counter ... ...
while FChange==1 && LoopD<=50 % outer loop formed by Step 2 and Step 3
    LoopD=LoopD+1;
    [LctRecC,ModeMtx]=ILDLC(X,ModeMtx,Pm.k,DistW,NumVal,LctRecC); % inner loop, i.e., Step 2
    if sum(LctRecFOld-LctRecC)==0 % judge if outer loop converge or not
        FChange=0;
    else 
        LctRecFOld=LctRecC; 
        EE=cell(1,Pm.Xwd); % expected effectiveness (EE)
        for i=1:Pm.Xwd
            EE{i}=zeros(Pm.k,NumVal(i)-1); % initialize EE matrix for A_i
        end
        CValLth=zeros(1,Pm.k);
        % compute EE under different cluster C_k, attribute A_i, and weight w_{i,j}
        for k=1:Pm.k % C_k
            CValList=find(LctRecC==k);
            CValLth(k)=length(CValList);
            if CValLth(k)~=0
                for i=1:Pm.Xwd % A_i
                    for j=1:NumVal(i) % w_{i,j}
                        for m=1:CValLth(k)
                            PVal=X(CValList(m),i); 
                            if PVal>j
                                EE{i}(k,j)=EE{i}(k,j)+NumVal(i)/(PVal-j); % *
                                %EE{i}(k,j)=EE{i}(k,j)+(NumVal(i)-1)/(PVal-j); % *
                            end
                            if PVal<j
                                EE{i}(k,j-1)=EE{i}(k,j-1)+NumVal(i)/(j-PVal); % *
                                %EE{i}(k,j-1)=EE{i}(k,j-1)+(NumVal(i)-1)/(j-PVal); % *
                            end
                        end
                    end
                end
            end
        end
        EEA=zeros(1,Pm.Xwd); % EE of different attributes
        for i=1:Pm.Xwd
            EEA(i)=sum(sum(EE{i})); % obtain \Phi_i, attribute-level importance
        end
        EEC=zeros(Pm.k,Pm.Xwd); % EE of different clusters
        for i=1:Pm.Xwd
            for k=1:Pm.k
                EEC(k,i)=sum(EE{i}(k,:)); % obtain B_{k,i}, cluster-level importance for A_i
            end
        end
        EECore=EE; % initialize the core of Eq.(5)
        for i=1:Pm.Xwd
            for k=1:Pm.k
                if EEC(k,i)~=0
                    EECore{i}(k,:)=1./EECore{i}(k,:); % obtain b_{k,i,j}, the core of Eq.(5)
                    EECore{i}(k,:)=(EECore{i}(k,:)/sum(EECore{i}(k,:)))*EEC(k,i); % computed according to Eq.(9)
                end
            end
            DistW{i}=sum(EECore{i}); % obtain the numerator in Eq.(9)
            DistW{i}=DistW{i}/sum(EEA); % divided by the denominator in Eq.(9)     
        end
    end
end
ACC=Eva_CA(LctRecC,XLable); % CA evaluation
ARI=Eva_ARI(LctRecC, XLable, 'adjusted'); % ARI evaluation
NMI=Eva_NMI(XLable, LctRecC); % NMI evaluation

% * NumVal(i) is an approximation of (NumVal(i)-1) in Eq.(6), for the extreme case that A_i has a 
% very small number of categories, NumVal(i) can be replaced by (NumVal(i)-1) for more accurate computation.
