
% compare the new idea with k-modes type algorithms

clear;
clc;

T=10; % set 10 runs of the experiment

%% Clustering for Caesarian Section data set
load CSO; % load data set
X=CSO;
CA=zeros(T,1); % initialize an empty container for clustering accuracy (CA)
ARI=zeros(T,1); % ... ... adjusted rank index (ARI)
NMI=zeros(T,1); % ... ... normalized mutual information (NMI)
[Pm.Xlth,Pm.Xwd]=size(X); % fetch the statistics of data set
XLable=X(:,Pm.Xwd);
Pm.Xwd=Pm.Xwd-1;
Pm.k=max(XLable);
rand('seed',9);
for t=1:T
    Modes=X(randperm(Pm.Xlth,Pm.k),1:Pm.Xwd); % randomly initialize k modes
    [CA(t),ARI(t),NMI(t)] = DLC_Main(X,Modes); % run DLC for clustering
end
disp(' ');
disp('clustering performance on CSO data set:');
AccMean=mean(CA) % demonstrate CA results
ARIMean=mean(ARI) % ... ARI ...
NMIMean=mean(NMI) % ... NMI ...

%% Clustering for Hayes-Roth data set
load HRO;
X=HRO;
CA=zeros(T,1);
ARI=zeros(T,1);
NMI=zeros(T,1);
[Pm.Xlth,Pm.Xwd]=size(X);
XLable=X(:,Pm.Xwd);
Pm.Xwd=Pm.Xwd-1;
Pm.k=max(XLable);
rand('seed',9);
for t=1:T
    Modes=X(randperm(Pm.Xlth,Pm.k),1:Pm.Xwd);
    [CA(t),ARI(t),NMI(t)] = DLC_Main(X,Modes);
end
disp(' ');
disp('clustering performance on HR data set:');
AccMean=mean(CA)
ARIMean=mean(ARI)
NMIMean=mean(NMI)

%% Clustering for Car Evaluation data set
load Car;
X=Car;
CA=zeros(T,1);
ARI=zeros(T,1);
NMI=zeros(T,1);
[Pm.Xlth,Pm.Xwd]=size(X);
XLable=X(:,Pm.Xwd);
Pm.Xwd=Pm.Xwd-1;
Pm.k=max(XLable);
rand('seed',9);
for t=1:T
    Modes=X(randperm(Pm.Xlth,Pm.k),1:Pm.Xwd);
    [CA(t),ARI(t),NMI(t)] = DLC_Main(X,Modes);
end
disp(' ');
disp('clustering performance on CE data set:');
AccMean=mean(CA)
ARIMean=mean(ARI)
NMIMean=mean(NMI)


%% Clustering for Nursery School data set
load NSO;
X=NSO;
CA=zeros(T,1);
ARI=zeros(T,1);
NMI=zeros(T,1);
[Pm.Xlth,Pm.Xwd]=size(X);
XLable=X(:,Pm.Xwd);
Pm.Xwd=Pm.Xwd-1;
Pm.k=max(XLable);
rand('seed',9);
for t=1:T
    Modes=X(randperm(Pm.Xlth,Pm.k),1:Pm.Xwd);
    [CA(t),ARI(t),NMI(t)] = DLC_Main(X,Modes);
end
disp(' ');
disp('clustering performance on NS data set:');
AccMean=mean(CA)
ARIMean=mean(ARI)
NMIMean=mean(NMI)



